require 'parallel'

module Pod
  class Command
    class Bin < Command
      class Repo < Bin
        class Update < Repo
          self.summary = '更新私有源'

          self.arguments = [
              CLAide::Argument.new('NAME', false)
          ]

          def self.options
            [
            ].concat(super)
          end

          def initialize(argv)
            @name = argv.shift_argument
            super
          end

          def run
            show_output = !config.silent?
            if @name
              config.sources_manager.update(@name, show_output)
            else
              Parallel.each(valid_sources, in_threads: 4) do |source|
                source.update(show_output)
              end
            end
          end

        end
      end
    end
  end
end

